/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package seatingassignment;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Scanner;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author Student-3
 */
public class AccountManager {
    public static final String SEPARATOR = ",";
    public static ArrayList<Account> accounts = new ArrayList<Account>();
    public static Account currentAccount;
    
    /**
     * Add a new account to accounts
     * @param _username username of the account
     * @param _password password of the account
     */
    public static void addAccount(String _username, String _password) {
        Account _acc=new Account(_username,_password);
        accounts.add(_acc);
    }
    
    /**
     * Add a new account to accounts
     * @param _acc the account
     */
    public static void addAccount(Account _acc) {
        accounts.add(_acc);
    }
    
    /**
     * The user logs in to the system
     * @return user's account
     * @throws FileNotFoundException
     * @throws Exception 
     */
    public static Account initAccount() throws FileNotFoundException, Exception {
        accounts=new ArrayList<Account>();
        
        //load every previous accounts
        Scanner terminalScanner=new Scanner(System.in);
        
        //file input
        Scanner csvScanner = new Scanner(new File("Accounts.csv"));
        while(csvScanner.hasNext()) {
            String[] nextUserInfo=csvScanner.nextLine().split(SEPARATOR);
            AccountManager.addAccount(nextUserInfo[0], nextUserInfo[1]);
        }
        csvScanner.close();
        
        int opt;
        String myUsername,myPassword;
        System.out.println("Input 1 to create a new account; input 2 to log in to the system; input 3 to delete an account.");
        opt=terminalScanner.nextInt();
        if(opt==1) {//create a new account
            
            while(true) {
                System.out.print("Create a new account:\nInput username: ");
                myUsername=terminalScanner.next();
                System.out.print("Input password: ");
                myPassword=terminalScanner.next();
                
                int ok=1;
                for(Account acc:accounts) {
                    if(acc.getUsername().equals(myUsername)) {
                        System.out.println("Account already exist! Create your account again.");
                        ok=0;
                        break;
                    }
                }
                if(ok==0) continue;
                System.out.println("Account successsfully created!");
                Account myAcc=new Account(myUsername,myPassword);
                AccountManager.addAccount(myAcc);
                
                try {
                    //add the new account to Accounts.csv
                    BufferedWriter csvWriter = new BufferedWriter(new FileWriter(new File("Accounts.csv")));
                    for(Account _acc:accounts) {
                        csvWriter.write(_acc.toCSV() + "\n");
                        csvWriter.flush();
                    }
                    csvWriter.close();
                    //add a new directory containing the Accounts information
                    File f=new File("Accounts/"+myUsername);
                    f.mkdir();
                    
                } catch (IOException ex) {
                    Logger.getLogger(AccountManager.class.getName()).log(Level.SEVERE, null, ex);
                }
                currentAccount=myAcc;
                
                
                try {
                    //input student namelist.csv
                    BufferedWriter csvWriter = new BufferedWriter(new FileWriter(new File("Accounts/"+myUsername+"/namelist.csv")));
                    csvWriter.write("<Input student namelist here. One student per line.>\n");
                    csvWriter.flush();
                    csvWriter.close();
                } catch (IOException ex) {
                    Logger.getLogger(AccountManager.class.getName()).log(Level.SEVERE, null, ex);
                }
                System.out.println("Import student list at "+"Accounts/"+myUsername+".csv");
                
                return myAcc;
            }
        }
        else if(opt==2) {//login
            if(accounts.isEmpty()) {
                throw new Exception("No registered users! How can you possibly login!");
            }
            while(true) {
                System.out.println("Please log in to the system: ");
                System.out.print("Input username: ");
                myUsername=terminalScanner.next(); 
                System.out.print("Input password: ");
                myPassword=terminalScanner.next();

                for(Account acc:accounts) {
                    if(acc.getUsername().equals(myUsername) && acc.getPassword().equals(myPassword)) {
                        System.out.println("Login Successful!");
                        currentAccount=acc;
                        return acc;
                    }
                }
                System.out.println("Username and password don't match. Input again.");
            }
        }
        else if(opt==3) {//delete an existing account
            System.out.println("Displaying all the accounts stored: ");
            for(Account acc:accounts)
                System.out.println(acc);
            System.out.println("Which account do you want to delete? Input the account name:");
            while(true) {
                int ok=0;
                String _userName=terminalScanner.next();
                for(int i=0;i<accounts.size();i++) {
                    if(accounts.get(i).getUsername().equals(_userName)) {
                        System.out.println("Account "+accounts.get(i).getUsername()+" is canceled");
                        accounts.remove(i);
                        
                        try {
                            BufferedWriter csvWriter = new BufferedWriter(new FileWriter(new File("Accounts.csv")));
                            for(Account _acc:accounts) {
                                csvWriter.write(_acc.toCSV() + "\n");
                                csvWriter.flush();
                            }
                            csvWriter.close();
                        } catch (IOException ex) {
                            Logger.getLogger(Account.class.getName()).log(Level.SEVERE, null, ex);
                        }
                        
                        String pathName="Accounts/"+_userName+"/";
                        System.out.println("The path is: "+pathName);
                        
                        File folder = new File(pathName);
                        File[] userFiles = folder.listFiles();
                        for(File file : userFiles) {
                            file.delete();
                        }
                                                
                        folder.delete();
                        System.out.println(folder.exists());
                        
                        ok=1;
                        break;
                    }
                }
                if(ok==1) break;
                else System.out.println("Account not found! Input again!");
            }
            return null;
        }
        else {
            throw new Exception("Invalid option!");
        }
    }
}
